**************************
*
* finds value on the return stack IF:
*
*   IF this is sbasic, and it is  in a program (NOT in command line)
*
*   THEN this returns the line nbr of the caller procdure,
*
*   ELSE this returns 0
*
*****************************************

	section none

	xref	sb_addstt     : in dev8_smsq_sbas_sttadd_rel
	xref	rt_int	      ; in dev8_smsq_sbas_sttadd_rel

	include dev8_keys_sbasic


; macro to define keywords where name & name of routine are the same
kwrd	macro	name
	dc.w	[name]-*
	dc.b	[.len(name)]
	dc.b	'[name]'
	endm

debut
	move.w	$110,a2
	lea	procs,a1
	jmp	(a2)		; link in new keywords
    

procs	dc.w	0,0,2
	kwrd	RET_STK
	kwrd	RET_STK2
	dc.l	0

ret_stk move.l	#-28,d0 	; direct PRINT
	bra.s	common
ret_stk2
	move.l	#-4,d0		; if assign to variable
common
	moveq	#0,d4
	tst.b	sb_cmdl(a6)	; command line parsing?
	bne	rt_int		; ... yes, so return line number 0
	cmp.l	#'SBAS',-4(a6)	; Sbasic ?
	bne	rt_int		; ... no, return 0

; this uses TT's sbas_sttadd_asm
sbas
	move.l	$3c(a6),a3
	add.l	a6,a3
	move.l	(a3,d0.l),d0	; point to return statement before last return statement  (the last one is the return from this function)

	jsr	sb_addstt	; find line and statement number
	swap	d0		; line number in upper word
	move.w	d0,d4		; return it now
	bra	rt_int
	end
